#include "../stdafx.h"

#include "DemoEntity.h"


void CDemoEntityContainer::onSceneStart( CScenario::eScene scene )
{
	TDemoEntityList::iterator it;
	TDemoEntityList::iterator itEnd = mEntities.end();
	for( it = mEntities.begin(); it != itEnd; ++it ) {
		IDemoEntity& e = **it;
		if( e.isActive( scene ) )
			e.onSceneStart( scene );
	}
}

void CDemoEntityContainer::onSceneEnd( CScenario::eScene scene )
{
	TDemoEntityList::iterator it;
	TDemoEntityList::iterator itEnd = mEntities.end();
	for( it = mEntities.begin(); it != itEnd; ++it ) {
		IDemoEntity& e = **it;
		if( e.isActive( scene ) )
			e.onSceneEnd( scene );
	}
}

void CDemoEntityContainer::beforeRendering()
{
	CScenario::eScene scene = CScenario::getInstance().getCurrScene();

	TDemoEntityList::iterator it;
	TDemoEntityList::iterator itEnd = mEntities.end();
	for( it = mEntities.begin(); it != itEnd; ++it ) {
		IDemoEntity& e = **it;
		if( e.isActive( scene ) )
			e.beforeRendering();
	}
}

void CDemoEntityContainer::update()
{
	CScenario::eScene scene = CScenario::getInstance().getCurrScene();

	TDemoEntityList::iterator it;
	TDemoEntityList::iterator itEnd = mEntities.end();
	for( it = mEntities.begin(); it != itEnd; ++it ) {
		IDemoEntity& e = **it;
		if( e.isActive( scene ) )
			e.update();
	}
}
