#include "../stdafx.h"

#include "Scenario.h"


CScenario::CScenario()
:	mInitTime(0), mCurrentTime(0),
	mCurrScene( (eScene)0 ),
	mCurrSceneTime(0),
	mCurrSceneLeft(0),
	mCurrSceneAlpha(0)
{
	mSceneDurations[WHITELINE]					= 3.5f;	// 3.5
	mSceneDurations[LINES]						= 15.0f; // 15
	mSceneDurations[LINES_BLOB]					= 20.0f; // 20
	mSceneDurations[LINES_CIRCLE_BLOB]			= 20.0f; // 20
	mSceneDurations[CIRCLE_BLOB]				= 3.0f; // 3
	mSceneDurations[WHEEL_BLOB]					= 3.0f; // 3
	mSceneDurations[WHEEL_QUAD_BLOB]			= 4.0f; // 4
	mSceneDurations[WHEEL_QUAD_BLOB_LINES]		= 20.0f; // 20
	mSceneDurations[FADEWHEEL_QUAD_BLOB_LINES]	= 20.0f; // 20
	mSceneDurations[FADE]						= 20.0f; // 20
	mSceneDurations[END]						= 20.0f; // 20

	float t = 0.0f;
	for( int i = 0; i < MAX_SCENES+1; ++i ) {
		mSceneStarts[i] = t;
		t += mSceneDurations[i];
	}
}


void CScenario::update( float time )
{
	mCurrentTime = time - mInitTime;
	int scene = 0;
	while( scene <= MAX_SCENES ) {
		if( mSceneStarts[scene] >= mCurrentTime )
			break;
		scene = scene+1;
	}

	scene -= 1;

	if( scene == MAX_SCENES ) {
		mCurrSceneTime = 0;
		mCurrSceneLeft = 0;
		mCurrSceneAlpha = 1;
	} else {
		mCurrSceneTime = mCurrentTime - mSceneStarts[scene];
		mCurrSceneLeft = mSceneDurations[scene] - mCurrSceneTime;
		mCurrSceneAlpha = mCurrSceneTime / mSceneDurations[scene];
	}

	mCurrScene = (eScene)scene;
}
