/**
 *  @file engine/Mesh.h
 *  Mesh renderer.
 */
#ifndef __MESH_H
#define __MESH_H

#include "DXObject.h"
#include "../common/resource/ResourceId.h"

class	CFrameTime;


class CMesh : public CDXObject {
public:
	CMesh( CResourceId const& meshId, CResourceId const& effectId, CResourceId const& textureId );
	virtual ~CMesh();

	D3DXMATRIX const& getWorldMatrix() const { return mWorldMatrix; }
	D3DXMATRIX& getWorldMatrix() { return mWorldMatrix; }

	D3DXMATRIX const& getTextureMatrix() const { return mTextureMatrix; }
	D3DXMATRIX& getTextureMatrix() { return mTextureMatrix; }

	D3DCOLOR const& getColor() const { return mColor; }
	D3DCOLOR& getColor() { return mColor; }

	virtual void render( CFrameTime const& frameTime );

protected:
	virtual void applyEffectParameters( ID3DXEffect& effect );

private:
	D3DXMATRIX	mWorldMatrix;
	D3DXMATRIX	mTextureMatrix;
	D3DCOLOR	mColor;

	CResourceId	mMeshId;
	CResourceId mEffectId;
	CResourceId mTextureId;
};

#endif
